<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): tiglContainersVertexBase.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_5923310312939235796ca11289acda83.html">common</a></li><li class="navelem"><a class="el" href="dir_5e9011f35b9434939eeeb25c7dbf1304.html">containers</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglContainersVertexBase.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglContainersVertexBase_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef TIGLVERTEXBASE_HPP_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define TIGLVERTEXBASE_HPP_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * INCLUDES</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#include &lt;set&gt;</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#include &lt;stdio.h&gt;</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="preprocessor">#include  &lt;stdint.h&gt;</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglContainersVertexTraits_8hpp.html">tiglContainersVertexTraits.hpp</a>&quot;</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglContainersEdgeBase_8hpp.html">tiglContainersEdgeBase.hpp</a>&quot;</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment"> * NAMESPACE</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="comment"> * TIGLContainersVertexBase class</span></div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> IdType = u<span class="keywordtype">int</span>_fast32_t&gt;</div>
<div class="line"><a name="l00089"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html">   89</a></span>&#160;<span class="keyword">class </span><a class="code" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;{</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="comment">    * type definitions</span></div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;   <span class="keyword">typedef</span> <a class="code" href="structTIGLContainersVertexTraits.html">TIGLContainersVertexTraits&lt;DataType, AlgDataType, EdgeType, IdType&gt;</a> <a class="code" href="structTIGLContainersVertexTraits.html">trait_type</a>;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::ID_TYPE ID_TYPE;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::OUT_EDGE_ITERATOR OUT_EDGE_ITERATOR;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::OUT_EDGE_BUF OUT_EDGE_BUF;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::EDGE_TYPE EDGE_TYPE;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::OUT_EDGE_ITERATOR EDGE_ITERATOR;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;   <span class="keyword">typedef</span> AlgDataType ALG_DATA_TYPE;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;   <span class="keyword">typedef</span> DataType DATA_TYPE;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="comment">    * constructor/destructor</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00119"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#ab12e0c19620ff872c8b793ff001f022b">  119</a></span>&#160;   <a class="code" href="classTIGLContainersVertexBase.html#ab12e0c19620ff872c8b793ff001f022b">TIGLContainersVertexBase</a>(IdType key)</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;   {</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;      <span class="keywordtype">id</span> = key;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;   }</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00132"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a0c2b931b7f439a72da6baaadbb6f753d">  132</a></span>&#160;   <a class="code" href="classTIGLContainersVertexBase.html#a0c2b931b7f439a72da6baaadbb6f753d">TIGLContainersVertexBase</a>(IdType key, DataType data, AlgDataType alg)</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;   {</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;      <span class="keywordtype">id</span> = key;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;      vertexData = data;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;      algData = alg;</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;   }</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00144"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a3887a721638627b063306724ad8cf22b">  144</a></span>&#160;   <a class="code" href="classTIGLContainersVertexBase.html#a3887a721638627b063306724ad8cf22b">TIGLContainersVertexBase</a>()</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;   {</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;   }</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;   ~<a class="code" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>()</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;   {</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;   }</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="comment">    * attributes</span></div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00159"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a3f6edf01d8830e0b5b8ad74549eeb085">  159</a></span>&#160;   IdType <a class="code" href="classTIGLContainersVertexBase.html#a3f6edf01d8830e0b5b8ad74549eeb085">id</a>;</div>
<div class="line"><a name="l00161"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a42054ed48c73a733e99f3ef80698e50b">  161</a></span>&#160;   DataType <a class="code" href="classTIGLContainersVertexBase.html#a42054ed48c73a733e99f3ef80698e50b">vertexData</a>;</div>
<div class="line"><a name="l00163"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#ac36b610433331bb36b1c05a1fa942418">  163</a></span>&#160;   AlgDataType <a class="code" href="classTIGLContainersVertexBase.html#ac36b610433331bb36b1c05a1fa942418">algData</a>;</div>
<div class="line"><a name="l00165"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a8e0e018b11f1fbe310789c332efed1b9">  165</a></span>&#160;   OUT_EDGE_BUF <a class="code" href="classTIGLContainersVertexBase.html#a8e0e018b11f1fbe310789c332efed1b9">outEdges</a>;</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="comment">    * methods</span></div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00178"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a260b170afbb1f183b7d6247a148fea83">  178</a></span>&#160;   <span class="keywordtype">bool</span> operator&lt;(const TIGLContainersVertexBase&lt;DataType, AlgDataType, EdgeType, IdType&gt; &amp; rhs) <span class="keyword">const</span></div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;   {</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;      <span class="keywordflow">return</span> (<span class="keywordtype">id</span> &lt; rhs.id);</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;   }</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00188"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#ac1f818aadbfdd77acf6eb5974339b582">  188</a></span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersVertexBase.html#ac1f818aadbfdd77acf6eb5974339b582">operator==</a>(<span class="keyword">const</span> <a class="code" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase&lt;DataType, AlgDataType, EdgeType, IdType&gt;</a> &amp; rhs)<span class="keyword"> const</span></div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;<span class="keyword">   </span>{</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;      <span class="keywordflow">return</span> (<span class="keywordtype">id</span> == rhs.<a class="code" href="classTIGLContainersVertexBase.html#a3f6edf01d8830e0b5b8ad74549eeb085">id</a>);</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;   }</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00199"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a7cc87d2b4157b298460486dab71dfb44">  199</a></span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersVertexBase.html#a7cc87d2b4157b298460486dab71dfb44">addEdge</a>(EdgeType &amp; x)</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;   {</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;      outEdges.push_back(x);</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;   }</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00210"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a2d6b5c292809922673ceb6fdb188b6b3">  210</a></span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersVertexBase.html#a2d6b5c292809922673ceb6fdb188b6b3">addEdge</a>(ID_TYPE &amp; target)</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;   {</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;      EDGE_TYPE newEdge(target);</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;      outEdges.push_back(newEdge);</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;   }</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00222"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#ae9dc66486575edee5b2901b6fa01b370">  222</a></span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersVertexBase.html#ae9dc66486575edee5b2901b6fa01b370">addEdge</a>(OUT_EDGE_BUF &amp; x)</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;   {</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;      <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR it = x.begin(); it != x.end(); ++it)</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;         outEdges.push_back(*it);</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;   }</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00235"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a355bc674650678249bd53adc12f1cb4d">  235</a></span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersVertexBase.html#a355bc674650678249bd53adc12f1cb4d">removeEdge</a>(IdType &amp; target)</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;   {</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;      <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR it = outEdges.begin(); it != outEdges.end(); ++it)</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;         <span class="keywordflow">if</span> (it-&gt;getNbr() == target)</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;         {</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;            outEdges.erase(it);</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;         }</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;   }</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00251"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#ae54bd25069156c7ff89a9907f2167b24">  251</a></span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersVertexBase.html#ae54bd25069156c7ff89a9907f2167b24">clearEdges</a>()</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;   {</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;      outEdges.clear();</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;   }</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00261"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a8aa2da8ab2f06ff33fb499ee42b228ce">  261</a></span>&#160;   <span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLContainersVertexBase.html#a8aa2da8ab2f06ff33fb499ee42b228ce">getNumOutEdges</a>()</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;   {</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;      <span class="keywordflow">return</span> outEdges.size();</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;   }</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00271"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a1fc8f9e57e5b9bfeaf5a33fe5f4d3d77">  271</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGLContainersVertexBase.html#a1fc8f9e57e5b9bfeaf5a33fe5f4d3d77">getNumDifferentNbr</a>()</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;   {</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;      uint_fast32_t numNbr = 0;</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;      <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR it = outEdges.begin(); it != outEdges.end(); ++it)</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;         <span class="keywordflow">if</span> (it-&gt;getNbr() != id)</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;            numNbr++;</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;      <span class="keywordflow">return</span> numNbr;</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;   }</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00286"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#afd0b2f0822224ebb4ee9b2d9b6ae7ba0">  286</a></span>&#160;   <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersVertexBase.html#afd0b2f0822224ebb4ee9b2d9b6ae7ba0">getChildren</a>(vector&lt;IdType&gt; &amp; vectChildren)</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;   {</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;      <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR it = outEdges.begin(); it != outEdges.end(); ++it)</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;         vectChildren.push_back(it-&gt;getNbr());</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;   }</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00299"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a6b9a5ee6ceed8269cfde06116fa4fb30">  299</a></span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersVertexBase.html#a6b9a5ee6ceed8269cfde06116fa4fb30">isConnected</a>(IdType node)</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;   {</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;      <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR it = outEdges.begin(); it != outEdges.end(); ++it)</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;         <span class="keywordflow">if</span> (it-&gt;getNbr() == node)</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;   }</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00312"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a776920aff39617337c8c0d11100fa948">  312</a></span>&#160;   <span class="keyword">inline</span> DataType &amp; <a class="code" href="classTIGLContainersVertexBase.html#a776920aff39617337c8c0d11100fa948">get_value</a>()</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;   {</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;      <span class="keywordflow">return</span> vertexData;</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;   }</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;</div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00323"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a782c440fc6c8ae87291f142239260091">  323</a></span>&#160;   <span class="keyword">inline</span> AlgDataType &amp; <a class="code" href="classTIGLContainersVertexBase.html#a782c440fc6c8ae87291f142239260091">getAlgData</a>()</div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;   {</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;      <span class="keywordflow">return</span> algData;</div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;   }</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00334"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a5c2f4752f5f1df26b608ddc6400777aa">  334</a></span>&#160;   <span class="keyword">inline</span> IdType <a class="code" href="classTIGLContainersVertexBase.html#a5c2f4752f5f1df26b608ddc6400777aa">getId</a>()</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;   {</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;      <span class="keywordflow">return</span> id;</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;   }</div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00345"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a077ed089a01250a2d15fc5acc7e3aaf6">  345</a></span>&#160;   <span class="keyword">inline</span> OUT_EDGE_ITERATOR <a class="code" href="classTIGLContainersVertexBase.html#a077ed089a01250a2d15fc5acc7e3aaf6">getBeginOutEdgeIterator</a>()</div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;   {</div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;      <span class="keywordflow">return</span> outEdges.begin();</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;   }</div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;</div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00356"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a3af614e7143fb092f6a3115514de319b">  356</a></span>&#160;   <span class="keyword">inline</span> OUT_EDGE_ITERATOR <a class="code" href="classTIGLContainersVertexBase.html#a3af614e7143fb092f6a3115514de319b">getEndOutEdgeIterator</a>()</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;   {</div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;      <span class="keywordflow">return</span> outEdges.end();</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;   }</div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00369"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#afb1a96d0d3ccc33e97c1b84af0a045d7">  369</a></span>&#160;   OUT_EDGE_ITERATOR <a class="code" href="classTIGLContainersVertexBase.html#afb1a96d0d3ccc33e97c1b84af0a045d7">get_edge</a>(ID_TYPE target)</div>
<div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;   {</div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;      <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR it = outEdges.begin(); it != outEdges.end(); ++it)</div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;         <span class="keywordflow">if</span> (it-&gt;get_target() == target)</div>
<div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;            <span class="keywordflow">return</span> it;</div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;      <span class="keywordflow">return</span> outEdges.end();</div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;   }</div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;</div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00383"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#af0521f19891d34cc1dfba07ec5bd83cd">  383</a></span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersVertexBase.html#af0521f19891d34cc1dfba07ec5bd83cd">isBiVertex</a>()</div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;   {</div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;   }</div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;</div>
<div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00394"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#ace8a3901abb1f925cd442ff24200b45f">  394</a></span>&#160;   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersVertexBase.html#ace8a3901abb1f925cd442ff24200b45f">compute</a>(<span class="keywordtype">void</span> *pIn = 0, <span class="keywordtype">void</span> *pOut = 0)</div>
<div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;   {</div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;   }</div>
<div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;</div>
<div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00404"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#a53510bd15bbce08013705a779d3b191a">  404</a></span>&#160;   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersVertexBase.html#a53510bd15bbce08013705a779d3b191a">init</a>()</div>
<div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;   {</div>
<div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;   }</div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;</div>
<div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00413"></a><span class="lineno"><a class="line" href="classTIGLContainersVertexBase.html#afcd5a44e577f8d3f69b6fb0b5f4fc2ec">  413</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGLContainersVertexBase.html#afcd5a44e577f8d3f69b6fb0b5f4fc2ec">getEdgesSize</a>()</div>
<div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;   {</div>
<div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;      <span class="keywordflow">return</span> outEdges.capacity() * <span class="keyword">sizeof</span>(EdgeType);</div>
<div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;   }</div>
<div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;</div>
<div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;   <span class="comment">// dummy functions (added for consistency but not needed)</span></div>
<div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;   <span class="keywordtype">void</span> addInEdge(EdgeType &amp; x)</div>
<div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;   {</div>
<div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;   }</div>
<div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;   <span class="keywordtype">void</span> addInEdge(IdType &amp; src)</div>
<div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;   {</div>
<div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;   }</div>
<div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;   <span class="keywordtype">void</span> addInEdge(vector&lt;EdgeType&gt; &amp; x)</div>
<div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;   {</div>
<div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;   }</div>
<div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;   <span class="keywordtype">bool</span> removeInEdge(IdType &amp; src)</div>
<div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;   {</div>
<div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;   }</div>
<div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;   EDGE_ITERATOR getBeginInEdgeIterator()</div>
<div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;   {</div>
<div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;      <span class="keywordflow">return</span> (EDGE_ITERATOR) NULL;</div>
<div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;   }</div>
<div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;   EDGE_ITERATOR getEndInEdgeIterator()</div>
<div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;   {</div>
<div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;      <span class="keywordflow">return</span> (EDGE_ITERATOR) NULL;</div>
<div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;   }</div>
<div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;   <span class="keyword">inline</span> uint_fast32_t get_num_in_edges()</div>
<div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;   {</div>
<div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;      <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;   }</div>
<div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> clear()</div>
<div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;   {</div>
<div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;      outEdges.clear();</div>
<div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;   }</div>
<div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;};</div>
<div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a355bc674650678249bd53adc12f1cb4d"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a355bc674650678249bd53adc12f1cb4d">TIGLContainersVertexBase::removeEdge</a></div><div class="ttdeci">bool removeEdge(IdType &amp;target)</div><div class="ttdoc">Removes an output edge identified by target node. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:235</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a0c2b931b7f439a72da6baaadbb6f753d"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a0c2b931b7f439a72da6baaadbb6f753d">TIGLContainersVertexBase::TIGLContainersVertexBase</a></div><div class="ttdeci">TIGLContainersVertexBase(IdType key, DataType data, AlgDataType alg)</div><div class="ttdoc">Overloaded constructor. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:132</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_afb1a96d0d3ccc33e97c1b84af0a045d7"><div class="ttname"><a href="classTIGLContainersVertexBase.html#afb1a96d0d3ccc33e97c1b84af0a045d7">TIGLContainersVertexBase::get_edge</a></div><div class="ttdeci">OUT_EDGE_ITERATOR get_edge(ID_TYPE target)</div><div class="ttdoc">Returns an iterator to the output edge with a given target. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:369</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a077ed089a01250a2d15fc5acc7e3aaf6"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a077ed089a01250a2d15fc5acc7e3aaf6">TIGLContainersVertexBase::getBeginOutEdgeIterator</a></div><div class="ttdeci">OUT_EDGE_ITERATOR getBeginOutEdgeIterator()</div><div class="ttdoc">Returns an iterator to the start of the outEdges buffer. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:345</div></div>
<div class="ttc" id="tiglContainersEdgeBase_8hpp_html"><div class="ttname"><a href="tiglContainersEdgeBase_8hpp.html">tiglContainersEdgeBase.hpp</a></div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a3af614e7143fb092f6a3115514de319b"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a3af614e7143fb092f6a3115514de319b">TIGLContainersVertexBase::getEndOutEdgeIterator</a></div><div class="ttdeci">OUT_EDGE_ITERATOR getEndOutEdgeIterator()</div><div class="ttdoc">Returns an iterator to the last edge of the outEdges buffer. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:356</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a6b9a5ee6ceed8269cfde06116fa4fb30"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a6b9a5ee6ceed8269cfde06116fa4fb30">TIGLContainersVertexBase::isConnected</a></div><div class="ttdeci">bool isConnected(IdType node)</div><div class="ttdoc">Checks if a given node is connected to the current node. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:299</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a2d6b5c292809922673ceb6fdb188b6b3"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a2d6b5c292809922673ceb6fdb188b6b3">TIGLContainersVertexBase::addEdge</a></div><div class="ttdeci">void addEdge(ID_TYPE &amp;target)</div><div class="ttdoc">Adds output edge (overloaded function) </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:210</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a776920aff39617337c8c0d11100fa948"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a776920aff39617337c8c0d11100fa948">TIGLContainersVertexBase::get_value</a></div><div class="ttdeci">DataType &amp; get_value()</div><div class="ttdoc">Returns the vertex data field. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:312</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a3f6edf01d8830e0b5b8ad74549eeb085"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a3f6edf01d8830e0b5b8ad74549eeb085">TIGLContainersVertexBase::id</a></div><div class="ttdeci">IdType id</div><div class="ttdoc">unique vertex ID </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:159</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_afd0b2f0822224ebb4ee9b2d9b6ae7ba0"><div class="ttname"><a href="classTIGLContainersVertexBase.html#afd0b2f0822224ebb4ee9b2d9b6ae7ba0">TIGLContainersVertexBase::getChildren</a></div><div class="ttdeci">void getChildren(vector&lt; IdType &gt; &amp;vectChildren)</div><div class="ttdoc">Returns the vertex id of all children. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:286</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_ab12e0c19620ff872c8b793ff001f022b"><div class="ttname"><a href="classTIGLContainersVertexBase.html#ab12e0c19620ff872c8b793ff001f022b">TIGLContainersVertexBase::TIGLContainersVertexBase</a></div><div class="ttdeci">TIGLContainersVertexBase(IdType key)</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:119</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a42054ed48c73a733e99f3ef80698e50b"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a42054ed48c73a733e99f3ef80698e50b">TIGLContainersVertexBase::vertexData</a></div><div class="ttdeci">DataType vertexData</div><div class="ttdoc">associated generic data </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:161</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_afcd5a44e577f8d3f69b6fb0b5f4fc2ec"><div class="ttname"><a href="classTIGLContainersVertexBase.html#afcd5a44e577f8d3f69b6fb0b5f4fc2ec">TIGLContainersVertexBase::getEdgesSize</a></div><div class="ttdeci">uint_fast32_t getEdgesSize()</div><div class="ttdoc">Returns memory usage for edges. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:413</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a8e0e018b11f1fbe310789c332efed1b9"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a8e0e018b11f1fbe310789c332efed1b9">TIGLContainersVertexBase::outEdges</a></div><div class="ttdeci">OUT_EDGE_BUF outEdges</div><div class="ttdoc">output edge buffer </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:165</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_af0521f19891d34cc1dfba07ec5bd83cd"><div class="ttname"><a href="classTIGLContainersVertexBase.html#af0521f19891d34cc1dfba07ec5bd83cd">TIGLContainersVertexBase::isBiVertex</a></div><div class="ttdeci">bool isBiVertex()</div><div class="ttdoc">Checks if the vertex type is TIGLContainersBiVertex. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:383</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a7cc87d2b4157b298460486dab71dfb44"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a7cc87d2b4157b298460486dab71dfb44">TIGLContainersVertexBase::addEdge</a></div><div class="ttdeci">void addEdge(EdgeType &amp;x)</div><div class="ttdoc">Adds output edge. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:199</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a53510bd15bbce08013705a779d3b191a"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a53510bd15bbce08013705a779d3b191a">TIGLContainersVertexBase::init</a></div><div class="ttdeci">virtual void init()</div><div class="ttdoc">Core init function: trivial realization in the core class. This function is overriden by the algorith...</div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:404</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a8aa2da8ab2f06ff33fb499ee42b228ce"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a8aa2da8ab2f06ff33fb499ee42b228ce">TIGLContainersVertexBase::getNumOutEdges</a></div><div class="ttdeci">uint_fast32_t getNumOutEdges()</div><div class="ttdoc">Returns the total number of output edges. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:261</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a3887a721638627b063306724ad8cf22b"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a3887a721638627b063306724ad8cf22b">TIGLContainersVertexBase::TIGLContainersVertexBase</a></div><div class="ttdeci">TIGLContainersVertexBase()</div><div class="ttdoc">Overloaded empty constructor. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:144</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_ac1f818aadbfdd77acf6eb5974339b582"><div class="ttname"><a href="classTIGLContainersVertexBase.html#ac1f818aadbfdd77acf6eb5974339b582">TIGLContainersVertexBase::operator==</a></div><div class="ttdeci">bool operator==(const TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt; &amp;rhs) const </div><div class="ttdoc">Overloaded equal operator for list ordering. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:188</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_ac36b610433331bb36b1c05a1fa942418"><div class="ttname"><a href="classTIGLContainersVertexBase.html#ac36b610433331bb36b1c05a1fa942418">TIGLContainersVertexBase::algData</a></div><div class="ttdeci">AlgDataType algData</div><div class="ttdoc">Algorithm-specific data. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:163</div></div>
<div class="ttc" id="tiglContainersVertexTraits_8hpp_html"><div class="ttname"><a href="tiglContainersVertexTraits_8hpp.html">tiglContainersVertexTraits.hpp</a></div></div>
<div class="ttc" id="structTIGLContainersVertexTraits_html"><div class="ttname"><a href="structTIGLContainersVertexTraits.html">TIGLContainersVertexTraits</a></div><div class="ttdoc">Basic type definitions for TIGLApiVertex class. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexTraits.hpp:56</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_ae54bd25069156c7ff89a9907f2167b24"><div class="ttname"><a href="classTIGLContainersVertexBase.html#ae54bd25069156c7ff89a9907f2167b24">TIGLContainersVertexBase::clearEdges</a></div><div class="ttdeci">void clearEdges()</div><div class="ttdoc">Clears all output edges. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:251</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a5c2f4752f5f1df26b608ddc6400777aa"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a5c2f4752f5f1df26b608ddc6400777aa">TIGLContainersVertexBase::getId</a></div><div class="ttdeci">IdType getId()</div><div class="ttdoc">Returns the vertex id. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:334</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_ae9dc66486575edee5b2901b6fa01b370"><div class="ttname"><a href="classTIGLContainersVertexBase.html#ae9dc66486575edee5b2901b6fa01b370">TIGLContainersVertexBase::addEdge</a></div><div class="ttdeci">void addEdge(OUT_EDGE_BUF &amp;x)</div><div class="ttdoc">Adds multiple ouput edges. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:222</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a782c440fc6c8ae87291f142239260091"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a782c440fc6c8ae87291f142239260091">TIGLContainersVertexBase::getAlgData</a></div><div class="ttdeci">AlgDataType &amp; getAlgData()</div><div class="ttdoc">Returns the algorithm data. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:323</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a1fc8f9e57e5b9bfeaf5a33fe5f4d3d77"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a1fc8f9e57e5b9bfeaf5a33fe5f4d3d77">TIGLContainersVertexBase::getNumDifferentNbr</a></div><div class="ttdeci">uint_fast32_t getNumDifferentNbr()</div><div class="ttdoc">Returns the number of neigbors excluding self (i.e., ignoring self cycles) </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:271</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html"><div class="ttname"><a href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a></div><div class="ttdoc">Core vertex class. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:89</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_ace8a3901abb1f925cd442ff24200b45f"><div class="ttname"><a href="classTIGLContainersVertexBase.html#ace8a3901abb1f925cd442ff24200b45f">TIGLContainersVertexBase::compute</a></div><div class="ttdeci">virtual bool compute(void *pIn=0, void *pOut=0)</div><div class="ttdoc">Core compute function: trivial realization in the core class. This function is overriden by the algor...</div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:394</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:52 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
